Index: channels/chan_sip.c
===================================================================
--- channels/chan_sip.c	(revision 369459)
+++ channels/chan_sip.c	(working copy)
@@ -3879,6 +3879,13 @@
 		transmit_request_with_auth(p, SIP_BYE, 0, XMIT_RELIABLE, 1);
 		append_history(p, "ReferBYE", "Sending BYE on transferer call leg %s", p->callid);
 		sip_scheddestroy(p, DEFAULT_TRANS_TIMEOUT);
+	} else if (p->ongoing_reinvite && ast_test_flag(&p->flags[0], SIP_PENDINGBYE)) {
+		p->ongoing_reinvite = 0;
+		ast_debug(3, "Finally hanging up channel after transfer: %s\n", p->callid);
+		stop_media_flows(p);
+		transmit_request_with_auth(p, SIP_BYE, 0, XMIT_RELIABLE, 1);
+		append_history(p, "ReferBYE", "Sending BYE on transferee call leg %s", p->callid);
+		sip_scheddestroy(p, DEFAULT_TRANS_TIMEOUT);
 	} else {
 		append_history(p, "AutoDestroy", "%s", p->callid);
 		ast_debug(3, "Auto destroying SIP dialog '%s'\n", p->callid);
